#include <gtkmm.h>
#include <libglademm.h>
#include <iostream>

class Demonstration : public SigC::Object {
public:
  Demonstration();

  Gtk::Window& get_window() { return *window_; }

private:
  Glib::RefPtr<Gnome::Glade::Xml> ui_;
  Gtk::Window *window_;
  Gtk::ImageMenuItem *new_, *quit_;

  void show_message() { std::cout << "New item clicked." << std::endl; }
  void quit()         { window_->hide(); }
};

Demonstration::Demonstration()
{
  ui_ = Gnome::Glade::Xml::create("project7.glade");
  ui_->get_widget("window1", window_);

  ui_->get_widget("new1", new_);
  new_->signal_activate().connect(SigC::slot(*this, &Demonstration::show_message));
  new_->activate();

  ui_->get_widget("quit1", quit_);
  quit_->signal_activate().connect(SigC::slot(*this, &Demonstration::quit));

  window_->show_all_children();
}

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);

  Demonstration d;
  Gtk::Main::run(d.get_window());

  return EXIT_SUCCESS;
}
